// https://github.com/TeamMaestro/nativescript-pspdfkit/tree/master/src
// export * from './syntaxhighlighter.ios';
import { SyntaxHighlighterViewBase, SyntaxHighlighterTheme } from './syntax-highlighter-view.base';
import { TextView } from '@nativescript/core';
import { Property, View } from '@nativescript/core/ui/core/view';
import { SyntaxHighlighterView } from './syntax-highlighter-view';

// export interface HighlightDelegate extends NSObjectProtocol {
//     shouldHighlightRange?(range: NSRange): boolean;
//     didHighlightRange?(range: NSRange): void;
// }

// export declare var HighlightDelegate: {
// 	prototype: HighlightDelegate;
// };

export declare const themeProperty: Property<SyntaxHighlighterViewBase, SyntaxHighlighterTheme>;
export declare const languageNameProperty: Property<SyntaxHighlighterView, string|null>;

/**
 * @platform ios
 */
export declare class SyntaxHighlighterTextView extends TextView implements SyntaxHighlighterViewBase {
    code: string;
    languageName: string | null;
    theme: SyntaxHighlighterTheme | string;

    private _highlightr;
    private _codeAttributedString;
    private _layoutManager;
    private _textContainer;
    createNativeView(): Object;
    initNativeView(): void;
    onMeasure(widthMeasureSpec: number, heightMeasureSpec: number): void;
}