import { SyntaxHighlighterViewBase, SyntaxHighlighterTheme } from './syntax-highlighter-view.base';
import { Property, View } from '@nativescript/core';

// export interface HighlightDelegate extends NSObjectProtocol {
//     shouldHighlightRange?(range: NSRange): boolean;
//     didHighlightRange?(range: NSRange): void;
// }

// export declare var HighlightDelegate: {
// 	prototype: HighlightDelegate;
// };


export declare const codeProperty: Property<SyntaxHighlighterViewBase, string>;
export declare const themeProperty: Property<SyntaxHighlighterViewBase, SyntaxHighlighterTheme>;
export declare const languageNameProperty: Property<SyntaxHighlighterView, string|null>;

/**
 * @platform ios, android
 */
export declare class SyntaxHighlighterView extends View implements SyntaxHighlighterViewBase {
    code: string;
    languageName: string | null;
    theme: SyntaxHighlighterTheme | string;

    createNativeView(): Object;
    initNativeView(): void;
    onMeasure(widthMeasureSpec: number, heightMeasureSpec: number): void;
}
